/***************************************************************************//**
 * @file
 * @brief Network Core Example - Socket
 *******************************************************************************
 * # License
 * <b>Copyright 2018 Silicon Laboratories Inc. www.silabs.com</b>
 *******************************************************************************
 *
 * The licensor of this software is Silicon Laboratories Inc.  Your use of this
 * software is governed by the terms of Silicon Labs Master Software License
 * Agreement (MSLA) available at
 * www.silabs.com/about-us/legal/master-software-license-agreement.  This
 * software is distributed to you in Source Code format and is governed by the
 * sections of the MSLA applicable to Source Code.
 *
 ******************************************************************************/

/********************************************************************************************************
 ********************************************************************************************************
 *                                               MODULE
 ********************************************************************************************************
 *******************************************************************************************************/

#ifndef  EX_NET_SOCK_H
#define  EX_NET_SOCK_H

/********************************************************************************************************
 ********************************************************************************************************
 *                                            INCLUDE FILES
 ********************************************************************************************************
 *******************************************************************************************************/

#include  <cpu/include/cpu.h>
#include  <net/include/net_type.h>

/********************************************************************************************************
 ********************************************************************************************************
 *                                         FUNCTION PROTOTYPES
 ********************************************************************************************************
 *******************************************************************************************************/

/********************************************************************************************************
 *                                        TCP EXAMPLE FUNCTIONS
 *******************************************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

CPU_BOOLEAN Ex_Net_SockTCP_Client(CPU_CHAR *p_ip_addr);

void Ex_Net_SockTCP_ServerIPv4(void);

void Ex_Net_SockTCP_ServerIPv6(void);

/********************************************************************************************************
 *                                        UDP EXAMPLE FUNCTIONS
 *******************************************************************************************************/

CPU_BOOLEAN Ex_Net_SockUDP_Client(CPU_CHAR *p_ip_addr);

void Ex_Net_SockUDP_ServerIPv4(void);

void Ex_Net_SockUDP_ServerIPv6(void);

/********************************************************************************************************
 *                                      SECURE EXAMPLE FUNCTIONS
 *******************************************************************************************************/

CPU_INT16S Ex_Net_SockSecureClientConnect(void);

CPU_INT16S Ex_Net_SockSecureServerInit(void);

/********************************************************************************************************
 *                                     MULTICAST EXAMPLE FUNCTIONS
 *******************************************************************************************************/

void Ex_Net_SockMCastEchoServer(CPU_CHAR     *p_name,
                                CPU_CHAR     *p_group_addr,
                                NET_PORT_NBR port);

#ifdef __cplusplus
}
#endif

/********************************************************************************************************
 ********************************************************************************************************
 *                                             MODULE END
 ********************************************************************************************************
 *******************************************************************************************************/

#endif // EX_NET_SOCK_H
